<?php 

class Client extends Page {
	
	static $db = array(
		"Sectors" => "Text",
		"MarketingMaterials" => "HTMLText",
		"ContactInfo" => "HTMLText",
		"Events" => "HTMLText",
		"IsActive" => "Text",
		"ExternalURL" => "Text",
		"IsFeatured" => "Text",
		"IsExitIPO" => "Text"
	);
	
	static $has_one = array(
		"ClientHolder" => "ClientHolder",
		"Logo" => "Image"
	);

	static $defaults = array(
		"ExternalURL" => 'http://www.horngroup.com/',
		"ProvideComments" => false,
		"ShowInMenus" => false,
		"ShowInSearch" => true
	);
	
	static $default_parent = "ClientHolder";

	static $has_many = array(
	);
	
	static $can_be_root = false;
	
	function getCMSFields() {

	   	$fields = parent::getCMSFields();
	   	
	   	$fields->addFieldToTab("Root.Content.Main", new CheckBoxField("IsActive", "Is this Client currently active?"), "Content");
	   	$fields->addFieldToTab("Root.Content.Main", new CheckBoxField("IsFeatured", "Feature this bad boy?"), "Content");
	   	$fields->addFieldToTab("Root.Content.Main", new CheckBoxField("IsExitIPO", "Is this sucker an Exit or an IPO?"), "Content");
	   	
		$fields->addFieldToTab("Root.Content.Main", new ImageUploadField("Logo", "Logo"), "Content");
		
		$sectorset = Page_Controller::GetSectors();
		$checkboxset = new CheckboxSetField("Sectors", "Sector(s)", $sectorset->toDropDownMap("SectorName", "SectorName"));
		$fields->addFieldToTab("Root.Content.Main", $checkboxset, "Content");
		
		$fields->addFieldToTab("Root.Content.Main", new TextField("ExternalURL", "Website Link"), "Content");
		$fields->addFieldToTab("Root.Content.AdditionalInfo", new HTMLEditorField("MarketingMaterials", "Marketing Materials", 14));
		$fields->addFieldToTab("Root.Content.AdditionalInfo", new HTMLEditorField("ContactInfo", "Contact Info", 14));
		$fields->addFieldToTab("Root.Content.AdditionalInfo", new HTMLEditorField("Events", "Events", 14));
	
		return $fields;

	}
	
	function IsActive() {
		if($this->GetField("IsActive") == 1) {
			return true;
		}
		return false;
	}
	
	public function DOMThumbnail() {
		if($i = $this->Logo()) {
			return $i->SetWidth(150);
		}
		return false;
	}
	
	/* for home page client logo dataobjectset */
	public function IsThird() {
		return ($this->iteratorPos % 3) == 0;
	}
	
	public function SectorsCollection() {

		$sectors = split(" *, *", trim($this->Sectors));
		$output = new DataObjectSet();
	
		$link = $this->getParent() ? $this->getParent()->Link('sector') : '';
	
		foreach($sectors as $sector) {
			$output->push(new ArrayData(array(
				'Sector' => $sector,
				'Link' => $link . '/' . urlencode($sector)
			)));
		}
	
		if($this->Sectors) {
			return $output;
		}
	}
	
	// add newly created items to category relation table
	function onAfterWrite() {
		parent::onAfterWrite();
		if($this->IsFeatured)  {
			// home page
			$home_page = DataObject::get_by_id("SiteTree", 1);
			$home_page->doPublish();
		}
	}
} 

class Client_Controller extends Page_Controller {
		
	public function GetCaseStudies() {
		return DataObject::get("CaseStudy","Status = 'Published' AND ClientID = ".$this->ID,"Sort ASC","");// JOIN: LEFT JOIN `Slide` ON `Slide`.`CaseStudyID` = `CaseStudy`.`ID` LEFT JOIN `File` ON `File`.`ID` = `Slide`.`ImageID`
	}
		
	public function ClientNews() {
		return DataObject::get("NewsPage","`NewsPage`.`ClientID` = ".$this->ID . " AND `CategoryName` = 'Client News'","Date DESC","LEFT JOIN `NewsPage_Categories` ON `NewsPage`.`ID` = `NewsPage_Categories`.`NewsPageID` LEFT JOIN `Category` ON `Category`.`ID` = `NewsPage_Categories`.`CategoryID`");
	}
	
	public function fullURL() {
		return Page_Controller::fullURL();
	}
	
}