<?php

class Sector extends DataObject {

	public static $db = array(
		"SectorName" => "Text",
		"SectorDescription" => "HTMLText",
		"IsEnabled" => "Text",
		"ClientsToShow" => "Text"
	);

	public static $has_one = array(
		"SectorHolder" => "SectorHolder"
	);

	public static $field_names = array(
		"SectorName" => "Name",
		"IsEnabled" => "Enabled?",
		"SectorShortDescription" => "Description",
		"GetAssociatedClients" => "Clients to Show"
	);
	
	static $can_be_root = false;
	
	static $default_parent = "SectorHolder";
	
	public function getCMSFields_forPopup() {

		$fields = new FieldSet();

		$fields->push(new TextField("SectorName", "Name"));
		$fields->push(new CheckboxField("IsEnabled", "Show this sector on the Industries page (this will not affect the client list)?"));
		$fields->push(new SimpleTinyMCEField("SectorDescription", "Description"));
		$fields->push(new CheckboxSetField("ClientsToShow", "Clients to Show", $this->GetClientsInThisSector()));
		return $fields;

	}
	
	public function GetAssociatedClients() {
		$output = "";
		$clients_to_show = split(" *, *", $this->ClientsToShow);
		foreach($clients_to_show as $client) {
			$client_object = DataObject::get_one("Client", "`Client`.`ID` = '".$client."'");
			if($client_object) {
				$output .= "<img style=\"width:50px;float:left;\" title=\"".$client_object->Title."\" src=\"".$client_object->Logo()->Filename."\"/>";
			}
		}
		return $output;
	}
	
	public function SectorName() {
		$this_sector = DataObject::get_by_id("Sector", $this->ID); 
		return $this_sector->SectorName;
	}
	
	public function GetClientsInThisSector() {
		// currently unable to show only clients assigned this sector - don't know why!!!
		$clients = DataObject::get("Client"/*, "'".$this->SectorName."' IN (`Client`.`Sectors`)"*/,"Status = 'Published'", "Title ASC"); 
		if($clients) {
			return $clients->toDropdownMap('ID','Title','(Select one or more options)',true);
		}
		return false;
	}
	
	public function IsEnabled() {
		return ($this->IsEnabled=="1") ? "Yes" : "No";
	}
	
	public function SectorShortDescription() {
		return Page_Controller::trunc($this->SectorDescription, 25);
	}
	
	// add newly created items to category relation table
	function onAfterWrite() {
		parent::onAfterWrite();
			// republish industries page
			$industries_page = DataObject::get_by_id("SiteTree", $this->SectorHolderID);
			$industries_page->doPublish();
	}
	

}